<?php

namespace Jlr\Tags\Api\Endpoint;

class UpdateTagGroup extends \Jane\OpenApiRuntime\Client\BaseEndpoint implements \Jane\OpenApiRuntime\Client\Psr7HttplugEndpoint
{
    protected $id;
    /**
     * 
     *
     * @param int $id The id of the tag-group to update.
     * @param \Jlr\Tags\Api\Model\TagGroup $requestBody 
     */
    function __construct(int $id, \Jlr\Tags\Api\Model\TagGroup $requestBody)
    {
        $this->id = $id;
        $this->body = $requestBody;
    }
    use \Jane\OpenApiRuntime\Client\Psr7HttplugEndpointTrait;
    function getMethod() : string
    {
        return 'PATCH';
    }
    function getUri() : string
    {
        return str_replace(array('{id}'), array($this->id), '/tag-groups/{id}');
    }
    function getBody(\Symfony\Component\Serializer\SerializerInterface $serializer, \Http\Message\StreamFactory $streamFactory = null) : array
    {
        if ($this->body instanceof \Jlr\Tags\Api\Model\TagGroup) {
            return array(array('Content-Type' => array('application/json')), $serializer->serialize($this->body, 'json'));
        }
        return array(array(), null);
    }
    function getExtraHeaders() : array
    {
        return array('Accept' => array('application/json'));
    }
    /**
     * {@inheritdoc}
     *
     *
     * @return null|\Jlr\Tags\Api\Model\TagGroupsIdPatchResponse200
     */
    protected function transformResponseBody(string $body, int $status, \Symfony\Component\Serializer\SerializerInterface $serializer, ?string $contentType = null)
    {
        if (200 === $status && 'application/json' === $contentType) {
            return $serializer->deserialize($body, 'Jlr\\Tags\\Api\\Model\\TagGroupsIdPatchResponse200', 'json');
        }
        if (401 === $status) {
        }
        if (404 === $status) {
        }
        if (422 === $status) {
        }
    }
}