<?php

namespace Jlr\Tags\Api\Normalizer;

use Jane\JsonSchemaRuntime\Reference;
use Symfony\Component\Serializer\Exception\InvalidArgumentException;
use Symfony\Component\Serializer\Normalizer\DenormalizerAwareInterface;
use Symfony\Component\Serializer\Normalizer\DenormalizerAwareTrait;
use Symfony\Component\Serializer\Normalizer\DenormalizerInterface;
use Symfony\Component\Serializer\Normalizer\NormalizerAwareInterface;
use Symfony\Component\Serializer\Normalizer\NormalizerAwareTrait;
use Symfony\Component\Serializer\Normalizer\NormalizerInterface;
class ReportNormalizer implements DenormalizerInterface, NormalizerInterface, DenormalizerAwareInterface, NormalizerAwareInterface
{
    use DenormalizerAwareTrait;
    use NormalizerAwareTrait;
    public function supportsDenormalization($data, $type, $format = null)
    {
        return $type === 'Jlr\\Tags\\Api\\Model\\Report';
    }
    public function supportsNormalization($data, $format = null)
    {
        return $data instanceof \Jlr\Tags\Api\Model\Report;
    }
    public function denormalize($data, $class, $format = null, array $context = array())
    {
        if (!is_object($data)) {
            throw new InvalidArgumentException();
        }
        $object = new \Jlr\Tags\Api\Model\Report();
        if (property_exists($data, 'id')) {
            $object->setId($data->{'id'});
        }
        if (property_exists($data, 'title')) {
            $object->setTitle($data->{'title'});
        }
        if (property_exists($data, 'subtitle')) {
            $object->setSubtitle($data->{'subtitle'});
        }
        if (property_exists($data, 'author')) {
            $object->setAuthor($data->{'author'});
        }
        if (property_exists($data, 'description')) {
            $object->setDescription($data->{'description'});
        }
        if (property_exists($data, 'published_at')) {
            $object->setPublishedAt($data->{'published_at'});
        }
        if (property_exists($data, 'image')) {
            $object->setImage($data->{'image'});
        }
        if (property_exists($data, 'favourited')) {
            $object->setFavourited($data->{'favourited'});
        }
        if (property_exists($data, 'archive_link')) {
            $object->setArchiveLink($data->{'archive_link'});
        }
        if (property_exists($data, 'download_link')) {
            $object->setDownloadLink($data->{'download_link'});
        }
        if (property_exists($data, 'share_link')) {
            $object->setShareLink($data->{'share_link'});
        }
        if (property_exists($data, 'tags')) {
            $values = array();
            foreach ($data->{'tags'} as $value) {
                $values[] = $this->denormalizer->denormalize($value, 'Jlr\\Tags\\Api\\Model\\Tag', 'json', $context);
            }
            $object->setTags($values);
        }
        return $object;
    }
    public function normalize($object, $format = null, array $context = array())
    {
        $data = new \stdClass();
        if (null !== $object->getId()) {
            $data->{'id'} = $object->getId();
        }
        if (null !== $object->getTitle()) {
            $data->{'title'} = $object->getTitle();
        }
        if (null !== $object->getSubtitle()) {
            $data->{'subtitle'} = $object->getSubtitle();
        }
        if (null !== $object->getAuthor()) {
            $data->{'author'} = $object->getAuthor();
        }
        if (null !== $object->getDescription()) {
            $data->{'description'} = $object->getDescription();
        }
        if (null !== $object->getPublishedAt()) {
            $data->{'published_at'} = $object->getPublishedAt();
        }
        if (null !== $object->getImage()) {
            $data->{'image'} = $object->getImage();
        }
        if (null !== $object->getFavourited()) {
            $data->{'favourited'} = $object->getFavourited();
        }
        if (null !== $object->getArchiveLink()) {
            $data->{'archive_link'} = $object->getArchiveLink();
        }
        if (null !== $object->getDownloadLink()) {
            $data->{'download_link'} = $object->getDownloadLink();
        }
        if (null !== $object->getShareLink()) {
            $data->{'share_link'} = $object->getShareLink();
        }
        if (null !== $object->getTags()) {
            $values = array();
            foreach ($object->getTags() as $value) {
                $values[] = $this->normalizer->normalize($value, 'json', $context);
            }
            $data->{'tags'} = $values;
        }
        return $data;
    }
}