<?php

namespace Jlr\Tags\Api\Normalizer;

use Jane\JsonSchemaRuntime\Reference;
use Symfony\Component\Serializer\Exception\InvalidArgumentException;
use Symfony\Component\Serializer\Normalizer\DenormalizerAwareInterface;
use Symfony\Component\Serializer\Normalizer\DenormalizerAwareTrait;
use Symfony\Component\Serializer\Normalizer\DenormalizerInterface;
use Symfony\Component\Serializer\Normalizer\NormalizerAwareInterface;
use Symfony\Component\Serializer\Normalizer\NormalizerAwareTrait;
use Symfony\Component\Serializer\Normalizer\NormalizerInterface;
class TagNormalizer implements DenormalizerInterface, NormalizerInterface, DenormalizerAwareInterface, NormalizerAwareInterface
{
    use DenormalizerAwareTrait;
    use NormalizerAwareTrait;
    public function supportsDenormalization($data, $type, $format = null)
    {
        return $type === 'Jlr\\Tags\\Api\\Model\\Tag';
    }
    public function supportsNormalization($data, $format = null)
    {
        return $data instanceof \Jlr\Tags\Api\Model\Tag;
    }
    public function denormalize($data, $class, $format = null, array $context = array())
    {
        if (!is_object($data)) {
            throw new InvalidArgumentException();
        }
        $object = new \Jlr\Tags\Api\Model\Tag();
        if (property_exists($data, 'id')) {
            $object->setId($data->{'id'});
        }
        if (property_exists($data, 'name')) {
            $object->setName($data->{'name'});
        }
        if (property_exists($data, 'user_generated')) {
            $object->setUserGenerated($data->{'user_generated'});
        }
        if (property_exists($data, 'description')) {
            $object->setDescription($data->{'description'});
        }
        if (property_exists($data, 'meta')) {
            $object->setMeta($data->{'meta'});
        }
        if (property_exists($data, 'children')) {
            $values = array();
            foreach ($data->{'children'} as $value) {
                $values[] = $this->denormalizer->denormalize($value, 'Jlr\\Tags\\Api\\Model\\Tag', 'json', $context);
            }
            $object->setChildren($values);
        }
        if (property_exists($data, 'group')) {
            $object->setGroup($this->denormalizer->denormalize($data->{'group'}, 'Jlr\\Tags\\Api\\Model\\TagGroup', 'json', $context));
        }
        if (property_exists($data, 'child_slugs')) {
            $values_1 = array();
            foreach ($data->{'child_slugs'} as $value_1) {
                $values_1[] = $value_1;
            }
            $object->setChildSlugs($values_1);
        }
        if (property_exists($data, 'group_id')) {
            $object->setGroupId($data->{'group_id'});
        }
        return $object;
    }
    public function normalize($object, $format = null, array $context = array())
    {
        $data = new \stdClass();
        if (null !== $object->getId()) {
            $data->{'id'} = $object->getId();
        }
        if (null !== $object->getName()) {
            $data->{'name'} = $object->getName();
        }
        if (null !== $object->getUserGenerated()) {
            $data->{'user_generated'} = $object->getUserGenerated();
        }
        if (null !== $object->getDescription()) {
            $data->{'description'} = $object->getDescription();
        }
        if (null !== $object->getMeta()) {
            $data->{'meta'} = $object->getMeta();
        }
        if (null !== $object->getChildren()) {
            $values = array();
            foreach ($object->getChildren() as $value) {
                $values[] = $this->normalizer->normalize($value, 'json', $context);
            }
            $data->{'children'} = $values;
        }
        if (null !== $object->getGroup()) {
            $data->{'group'} = $this->normalizer->normalize($object->getGroup(), 'json', $context);
        }
        if (null !== $object->getChildSlugs()) {
            $values_1 = array();
            foreach ($object->getChildSlugs() as $value_1) {
                $values_1[] = $value_1;
            }
            $data->{'child_slugs'} = $values_1;
        }
        if (null !== $object->getGroupId()) {
            $data->{'group_id'} = $object->getGroupId();
        }
        return $data;
    }
}