<?php

namespace Jlr\Tags\Endpoints\Concerns;

use Jane\OpenApiRuntime\Client\Exception\InvalidFetchModeException;
use Jlr\Tags\Api\Client;
use Psr\Http\Message\ResponseInterface;
use Symfony\Component\Serializer\SerializerInterface;

trait Psr7HttplugEndpointTrait
{
    public function parsePSR7Response(
        ResponseInterface $response,
        SerializerInterface $serializer,
        string $fetchMode = Client::FETCH_OBJECT
    ) {
        if ($fetchMode === Client::FETCH_OBJECT) {
            return $this->transformResponseBody(
                (string) $response->getBody(),
                $response->getStatusCode(),
                $serializer,
                $response->getHeader('Content-Type')[0] ?? ''
            );
        }

        if ($fetchMode === Client::FETCH_RESPONSE) {
            return $response;
        }

        throw new InvalidFetchModeException(sprintf('Fetch mode %s is not supported', $fetchMode));
    }
}
